---
title: Using Feature Policy
slug: Web/HTTP/Feature_Policy/Using_Feature_Policy
tags:
  - Feature Policy
  - Feature-Policy
  - HTTP
  - Permissions
  - Privileges
  - Reference
  - Security
  - access
  - delegation
  - header
---
<div>{{HTTPSidebar}}</div>

<p><a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a> allows you to control which origins can use which features, both in the top-level page and in embedded frames. Essentially, you write a policy, which is an allowed list of origins for each feature. For every feature controlled by Feature Policy, the feature is only enabled in the current document or frame if its origin matches the allowed list of origins.</p>

<p>For each policy-controlled feature, the browser maintains a list of origins for which the feature is enabled, known as an allowlist. If you do not specify a policy for a feature, then a default allowlist will be used. The default allowlist is specific to each feature.</p>

<div class="note">
<p>The <code>Feature-Policy</code> header has now been renamed to <code>Permissions-Policy</code> in the spec, and this article will eventually be updated to reflect that change.</p>
</div>

<h2 id="Writing_a_policy">Writing a policy</h2>

<p>A policy is described using a set of individual policy directives. A policy directive is a combination of a defined feature name, and an allowlist of origins that can use the feature. Features within a policy are separated by semicolons.</p>

<h3 id="allowlist">allowlist</h3>

<p>An <code>allowlist</code> is a list of origins that takes one or more of the following values, separated by spaces:</p>

<ul>
 <li><code>*</code>: The feature will be allowed in this document, and all nested browsing contexts (iframes) regardless of their origin.</li>
 <li><code>'self'</code>: The feature will be allowed in this document, and in all nested browsing contexts (iframes) in the same origin.</li>
 <li><code>'src'</code>: (In an iframe <code>allow</code> attribute only) The feature will be allowed in this iframe, as long as the document loaded into it comes from the same origin as the URL in the iframe's {{HTMLElement('iframe','src','#Attributes')}} attribute.
  <div class="note">The <code>'src'</code> origin is used in the iframe <code>allow</code> attribute only, and is the <em>default</em> <code>allowlist</code> value. </div>
 </li>
 <li><code>'none'</code>: The feature is disabled in top-level and nested browsing contexts.</li>
 <li>&lt;origin(s)&gt;: The feature is allowed for specific origins (for example, https://example.com). Origins should be separated by a space.</li>
</ul>

<p>The values <code>*</code> (enable for all origins) or <code>'none'</code> (disable for all origins) may only be used alone, while <code>'self'</code> and <code>'src'</code> may be used with one or more origins.</p>

<p>Features are each defined to have a default allowlist, which is one of:</p>

<ul>
 <li><code>*</code>: The feature is allowed by default in top-level browsing contexts and all nested browsing contexts (iframes).</li>
 <li><code>'self'</code>: The feature is allowed by default in top-level browsing contexts and in nested browsing contexts (iframes) in the same origin. The feature is not allowed in cross-origin documents in nested browsing contexts.</li>
 <li><code>'none'</code>: The feature is disabled in top-level and nested browsing contexts.</li>
</ul>

<h2 id="Specifying_your_policy">Specifying your policy</h2>

<p>Feature Policy provides two ways to specify policies to control features:</p>

<ul>
 <li>The {{httpheader('Feature-Policy')}} HTTP header.</li>
 <li>The {{htmlattrxref("allow", "iframe")}} attribute on {{htmlelement("iframe")}}s.</li>
</ul>

<p>The primary difference between the HTTP header and the <code>allow</code> attribute is that the allow attribute only controls features within an iframe. The header controls features in the response and any embedded content within the page.</p>

<h3 id="The_Feature-Policy_HTTP_header">The Feature-Policy HTTP header</h3>

<p>You can send the <code>Feature-Policy</code> HTTP header with the response of a page. The value of this header is a policy to be enforced by the browser for the given page. It has the following structure.</p>

<pre class="brush: bash notranslate">Feature-Policy: &lt;feature name&gt; &lt;allowlist of origin(s)&gt;</pre>

<p>For example, to block all content from using the Geolocation API across your site:</p>

<pre class="brush: bash notranslate">Feature-Policy: geolocation 'none'</pre>

<p>Several features can be controlled at the same time by sending the HTTP header with a semicolon-separated list of policy directives, or by sending a separate header for each policy.</p>

<p>For example, the following are equivalent:</p>

<pre class="brush: bash notranslate">Feature-Policy: unsized-media 'none'; geolocation 'self' https://example.com; camera *;

Feature-Policy: unsized-media 'none'
Feature-Policy: geolocation 'self' https://example.com
Feature-Policy: camera *;
</pre>

<h3 id="The_iframe_allow_attribute">The iframe allow attribute</h3>

<p>The second way to use Feature Policy is for controlling content within an iframe. Use the <code>allow</code> attribute to specify a policy list for embedded content.</p>

<p>For example, allow all browsing contexts within this iframe to use fullscreen:</p>

<pre class="brush: html notranslate">&lt;iframe src="https://example.com..." allow="fullscreen"&gt;&lt;/iframe&gt;</pre>

<p>The default <code>&lt;iframe&gt;</code> <a href="#allowlist">allowlist</a> value is <code>'src'</code>, so this is equivalent to:</p>

<pre class="brush: html notranslate">&lt;iframe src="https://example.com..." allow="fullscreen 'src'"&gt;&lt;/iframe&gt;</pre>

<p>This example allows <code>&lt;iframe&gt;</code> content on a particular origin to access the user's location:</p>

<pre class="brush: html notranslate">&lt;iframe src="https://google-developers.appspot.com/demos/..."
        allow="geolocation https://google-developers.appspot.com"&gt;&lt;/iframe&gt;
</pre>

<p>Similar to the HTTP header, several features can be controlled at the same time by specifying a semicolon-separated list of policy directives.</p>

<p>For example, this blocks the <code>&lt;iframe&gt;</code> from using the camera and microphone:</p>

<pre class="brush: html notranslate">&lt;iframe allow="camera 'none'; microphone 'none'"&gt;
</pre>

<h2 id="Inheritance_of_policy_for_embedded_content">Inheritance of policy for embedded content</h2>

<p>Scripts inherit the policy of their browsing context, regardless of their origin. That means that top-level scripts inherit the policy from the main document.</p>

<p>All iframes inherit the policy of their parent page. If the iframe has an <code>allow</code> attribute, the policies of the parent page and the <code>allow</code> attribute are combined, using the most restrictive subset. For an iframe to have a feature enabled, the origin must be in the allowlist for both the parent page and the allow attribute.</p>

<p>Disabling a feature in a policy is a one-way toggle. If a feature has been disabled for a child frame by its parent frame, the child cannot re-enable it, and neither can any of the child's descendants.</p>

<h2 id="Enforcing_best_practices_for_good_user_experiences">Enforcing best practices for good user experiences</h2>

<p>It's difficult to build a website that uses all the latest best practices and provides great performance and user experiences. As the website evolves, it can become even harder to maintain the user experience over time. You can use feature policies to specify the desired best practices, and rely on the browser to enforce the policies to prevent regressions.</p>

<p>There are several policy-controlled features designed to represent functionality that can negatively impact the user experience. These features include:</p>

<ul>
 <li>Layout-inducing Animations</li>
 <li>Unoptimized (poorly compressed) images</li>
 <li>Oversized images</li>
 <li>Synchronous scripts</li>
 <li>Synchronous XMLHttpRequest</li>
 <li>Unsized media</li>
</ul>

<p>To avoid breaking existing web content, the default for such policy-controlled features is to allow the functionality to be used by all origins. That is, the default allowlist is <code>'*'</code> for each feature. Preventing the use of the sub-optimal functionality requires explicitly specifying a policy that disables the features.</p>

<p>For new content, you can start developing with a policy that disables all the features. This approach ensures that none of the functionality is introduced. When applying a policy to existing content, testing is likely required to verify it continues to work as expected. This is especially important for embedded or third-party content that you do not control.</p>

<p>To turn on the enforcement of all the best practices, specify the policy as below.</p>

<p>Send the following the HTTP header:</p>

<pre class="brush: bash notranslate">Feature-Policy: layout-animations 'none'; unoptimized-images 'none'; oversized-images 'none'; sync-script 'none'; sync-xhr 'none'; unsized-media 'none';</pre>

<p>Using the <code>&lt;iframe&gt;</code> <code>allow</code> attribute:</p>

<pre class="brush: html notranslate">&lt;iframe src="https://example.com..." allow="layout-animations 'none'; unoptimized-images 'none'; oversized-images 'none'; sync-script 'none'; sync-xhr 'none'; unsized-media 'none';"&gt;&lt;/iframe&gt;</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a></li>
 <li>{{HTTPHeader("Feature-Policy")}} header</li>
 <li>{{HTMLElement('iframe','allow','#Attributes')}} attribute on iframes</li>
 <li>{{HTTPHeader("Content-Security-Policy")}} header</li>
 <li>{{HTTPHeader("Referrer-Policy")}} header</li>
 <li><a href="/en-US/docs/Web/Privacy">Privacy, permissions, and information security</a></li>
</ul>
